// Climate Framework for Uncertainty, Negotiation and Distribution
// Version 3.5
// (c) David Anthoff and Richard S.J. Tol
// http://www.fund-model.org
using System;
using System.Collections.Generic;
using System.Text;
using System.Reflection.Emit;

namespace Esmf
{
    public delegate int Enum2IntConversionDelegate<T>(T v);

    public class Enum2IntConversionSingleton<T>
    {
        private static readonly Enum2IntConversionSingleton<T> _instance = new Enum2IntConversionSingleton<T>();

        private Enum2IntConversionDelegate<T> _enumConversionDelegate;

        public Enum2IntConversionDelegate<T> Delegate
        {
            get { return _enumConversionDelegate; }
        }

        Enum2IntConversionSingleton()
        {
            DynamicMethod _dm = new DynamicMethod("Enum2IntConversion", typeof(int), new Type[] { typeof(T) }, typeof(T));
            ILGenerator il = _dm.GetILGenerator();
            il.Emit(OpCodes.Ldarg_0);
            il.Emit(OpCodes.Ret);

            _enumConversionDelegate = (Enum2IntConversionDelegate<T>)_dm.CreateDelegate(typeof(Enum2IntConversionDelegate<T>));

        }

        public static Enum2IntConversionSingleton<T> Instance
        {
            get { return _instance; }
        }
    }
}
