﻿// Climate Framework for Uncertainty, Negotiation and Distribution
// Version 3.5
// (c) David Anthoff and Richard S.J. Tol
// http://www.fund-model.org
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Fund
{
    public abstract class Parameter
    {
        protected ParameterKey m_key;
        protected Random _rand;
        protected abstract double GetValue();

        public Parameter(ParameterKey KeyData, Random rand)
        {
            m_key = KeyData;
            _rand = rand;
        }

        public abstract void SetToBestGuessValue();
        public abstract void SetToRandomValue();

        public ParameterKey Key { get { return m_key; } }
        public double Value { get { return GetValue(); } }

        public abstract double Mean { get; }
        public abstract double StdDev { get; }
    }
}
