﻿// Climate Framework for Uncertainty, Negotiation and Distribution
// Version 3.5
// (c) David Anthoff and Richard S.J. Tol
// http://www.fund-model.org
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Fund
{
    public class YearParameterKey : ParameterKey
    {
        private int _year;

        public YearParameterKey(string name, int year)
            : base(name)
        {
            _year = year;
        }

        public override bool Equals(object obj)
        {
            if (obj == null) return false;
            if (Object.ReferenceEquals(this, obj)) return true;
            if (this.GetType() != obj.GetType()) return false;

            YearParameterKey castedObj = (YearParameterKey)obj;

            if (this._name.Equals(castedObj._name) && this._year.Equals(castedObj._year)) return true;

            return false;
        }

        public override int GetHashCode()
        {
            return _name.GetHashCode() ^ _year;
        }


        public override string ToString()
        {
            return String.Format("{0};{1}", Name, Year + 1950);
        }

        public int Year { get { return _year; } }
    }
}
