﻿// Climate Framework for Uncertainty, Negotiation and Distribution
// Version 3.5
// (c) David Anthoff and Richard S.J. Tol
// http://www.fund-model.org
using System.Collections.Generic;
using System;

namespace Fund
{

    public class YearParameterConnector : Esmf.IParameter1Dimensional<Esmf.Timestep, double>
    {
        private double[] _values;

        public double this[Esmf.Timestep t] { get { return GetItem(t); } }

        public double GetItem(Esmf.Timestep t)
        {
            return _values[t.Value];
        }

        public YearParameterConnector(Parameters param, string name)
        {
            _values = new double[LegacyConstants.NYear + 1];

            for (int i = 0; i <= LegacyConstants.NYear; i++)
                _values[i] = param.GetItemByKey(new YearParameterKey(name, i));
        }

        public System.Collections.Generic.IEnumerable<Esmf.Parameter1DimensionalMember<Esmf.Timestep, System.Double>> GetEnumerator()
        {
            throw new NotImplementedException();
        }
    }
}