﻿// Climate Framework for Uncertainty, Negotiation and Distribution
// Version 3.5
// (c) David Anthoff and Richard S.J. Tol
// http://www.fund-model.org
namespace Fund
{

    public class AverageEquityWeightingFirstPeriod : WeightingScheme
    {

        public override void CalculateWeights(ModelOutput ModelOutput)
        {
            double i_worldIncome, i_worldPopulation;
            double i_equityWeight;

            i_worldIncome = 0;
            i_worldPopulation = 0;

            for (int l = 1; l <= LegacyConstants.NoReg; l++)
            {
                i_worldIncome = i_worldIncome + ModelOutput.Incomes[50, l];
                i_worldPopulation = i_worldPopulation + ModelOutput.Populations[50, l];
            }

            // TODO -oDavid Anthoff: Change start of "real" period to constant
            for (int i = 50; i <= LegacyConstants.NYear; i++)
            {
                for (int l = 1; l <= LegacyConstants.NoReg; l++)
                {
                    i_equityWeight = (i_worldIncome / i_worldPopulation) / (ModelOutput.Incomes[50, l] / ModelOutput.Populations[50, l]);
                    AddWeight(i, l, i_equityWeight);
                }
            }
        }

        protected override string GetName()
        {
            return "Average equity weighting first period";
        }
    }
}