﻿// Climate Framework for Uncertainty, Negotiation and Distribution
// Version 3.5
// (c) David Anthoff and Richard S.J. Tol
// http://www.fund-model.org
using System.Collections.Generic;

namespace Fund
{
    public class RegionFilter : WeightingScheme
    {
        private HashSet<int> _regions;

        protected override string GetName()
        {
            return "Region filter";
        }

        protected override double GetWeight(int Year, int Region)
        {
            if (_regions.Contains(Region))
                return 1.0;
            else
                return 0.0;
        }

        public override void CalculateWeights(ModelOutput ModelOutput)
        {
        }

        public RegionFilter(int[] regions)
        {
            _regions = new HashSet<int>(regions);
        }

    }
}