﻿// Climate Framework for Uncertainty, Negotiation and Distribution
// Version 3.5
// (c) David Anthoff and Richard S.J. Tol
// http://www.fund-model.org
namespace Fund
{

    public class WeitzmanStepDecline : WeightingScheme
    {

        public override void CalculateWeights(ModelOutput ModelOutput)
        {
            double i_discountFactor;
            double i_discountRate;

            i_discountFactor = 1;
            // TODO -oDavid Anthoff: Change start of "real" period to constant
            for (int i = 50; i <= LegacyConstants.NYear; i++)
            {
                for (int l = 1; l <= LegacyConstants.NoReg; l++)
                    AddWeight(i, l, i_discountFactor);

                if (i < 55)
                    i_discountRate = 0.04;
                else if (i < 75)
                    i_discountRate = 0.03;
                else if (i < 125)
                    i_discountRate = 0.02;
                else if (i < 350)
                    i_discountRate = 0.01;
                else
                    i_discountRate = 0.00;

                i_discountFactor = i_discountFactor / (1.00 + i_discountRate);
            }
        }

        public WeitzmanStepDecline()
            : base()
        {
        }

        protected override string GetName()
        {
            return "Weitzman step decline";
        }
    }
}